<?php
require_once('PolynomialApproximation.php');
$motosat_ip= "192.168.1.250";
$motosat_url= "http://".$motosat_ip."/motor.xml";
$modem_ip = "192.168.0.1";
//$modem_ip = "http://localhost/motosat/attic";
//$modem_strengt_url = $modem_ip."/sqf/sqfdisp/index.html";
//$modem_strengt_url_good = "http://localhost/motosat/attic/sqf/sqfdisp/index.html";
//$modem_strengt_url_bad = "http://localhost/motosat/attic/sqf/sqfdisp/index.html1";
//$modem_strengt_url = "http://192.168.0.1/sqf/sqfdisp/index.html";
$modem_strengt_url = "http://".$modem_ip."/sqf/sqfdisp/index.html";
$AZ_CPD = 12.74445;
$EL_CPD = 75.78567;
$SK_CPD = 8.34;
$AZ_0 =  0.0;    // degrees
$EL_0 =  0.0;    // degrees
$SK_0 = 55.7554; // degrees
$AZ_CMAX =  4790;
$EL_CMAX = 10979;
$SK_CMAX =   931;
$MODEM_THRESHOLD = 17.0; // consider something if modem strength is above
$OVERSHOOT = 1; // final steps absolute error
$LATE_STOP_AZ = 30; // steps

// Rescan azimuth after noticed a satellite during area scan
$AZ_PLAY = 1.0;         // Hysteresis caused by mechanical play (degrees)
$AZ_RESCAN = 8;         // (degrees) around expected center
$AZ_RESCAN_STEP = 0.25; // (degrees)
$USABLE_FRACT =   0.6;  // use ony samples not less than this fraction of maximal
$USABLE_POW =     1.0;  // transform (maxstrengh - strengh) by applying pow - 1.2 ...1.3 may have marginal improvements
$ARGMAX_OURSIDE = 0.2;  // Allow  argmax outside of the measured range by this fraction 
/*
http://192.168.1.250/motor.xml?Action=ElUp&Distance=0.5&Units=1 0.5 degree up

http://192.168.1.250/motor.xml?Action=ElUp&Distance=1&Units=0 1 step up
http://192.168.1.250/motor.xml?Action=ElDn&Distance=1&Units=0 1 step down
http://192.168.1.250/motor.xml?Action=AzUp&Distance=1&Units=0 1 sep az +
http://192.168.1.250/motor.xml?Action=AzDn&Distance=1&Units=0 1 sep az -

SK0 = 465 steps
http://192.168.1.250/motor.xml?Action=SkUp&Distance=1&Units=0 1 step sk +
http://192.168.1.250/motor.xml?Action=SkDn&Distance=1&Units=0 1 step sk -
http://192.168.1.250/motor.xml?Action=Stop&Distance=100&Units=1 - stop 

*/

//php > var_dump($DishAngle);
//array(3) {[0]=> float(9.97), [1]=> float(0), [2]=> float(0)}
$dbg_file = fopen("/home/eyesis/git/motosat/attic/logs/test03.log","w");
fprintf($dbg_file,"test log\n");

if (false) {
    $data = Array(5,6,7,9,9,10,11,11,12,12,11,11,10,10,10,36,40,45,47,51,51,51,49,48,43,38,30,30,30,10,10,10,10);
    $rslt = findMax1d($data, $USABLE_FRACT, $USABLE_POW, $ARGMAX_OURSIDE);
    print_r($rslt);
    print("\n");
    exit (0);
}

if (false) {
    print("<p>".date('l jS \of F Y h:i:s A')."</p>");
    $modem_strength= getModemStrength();
    for ($i=0;$i<10;$i++){
        //$modem_strength= getModemStrength();
        $xml_state = simplexml_load_file($motosat_url); // 0.29 sec
    }
    print("<p>modem_strength=".$modem_strength." file=".$modem_strengt_url."</p>");
    print("<p>".date('l jS \of F Y h:i:s A')."</p>");
    exit (0);
}


$xml_state = simplexml_load_file($motosat_url); // use current as default gor HTTP GET
//$DishCount = getDishCounts (xml_state);
$DishAngle = getDishAngles ($xml_state);

$dbg =    false; // true;
$multi=   true; // false;
$wnd_az = 0;
$wnd_el = 0;
$scan_step = 1.0;
$min_strength = $MODEM_THRESHOLD;

if (isset($_GET["dbg"]))          { $dbg=myval($_GET["dbg"]);}
if (isset($_GET["multi"]))        { $multi=myval($_GET["multi"]);}
if (isset($_GET["az"]))           { $DishAngle[0] = myfval($_GET["az"]);}
if (isset($_GET["el"]))           { $DishAngle[1] = myfval($_GET["el"]);}
if (isset($_GET["sk"]))           { $DishAngle[2] = myfval($_GET["sk"]);}

if (isset($_GET["wnd_az"]))       { $wnd_az =       myfval($_GET["wnd_az"]);}
if (isset($_GET["wnd_el"]))       { $wnd_el =       myfval($_GET["wnd_el"]);}
if (isset($_GET["scan_step"]))    { $scan_step =    myfval($_GET["scan_step"]);}
if (isset($_GET["min_strength"])) { $min_strength = myfval($_GET["min_strength"]);}
$scan_mode = ($wnd_az > 0) || ($wnd_el > 0);

if ($scan_mode){
    $xml_state = scan_window($min_strength, $DishAngle, $wnd_az, $wnd_el, $scan_step);
    $Success =       $xml_state->Success;
    
    if (intval ($Success)){
        peakAzimuth($xml_state, $AZ_PLAY,$AZ_RESCAN, $AZ_RESCAN_STEP, $USABLE_FRACT, $USABLE_POW, $ARGMAX_OURSIDE);
        $xml_state = simplexml_load_file($motosat_url);
    }
    
    $xml = new SimpleXMLElement("<?xml version='1.0'?><motosat/>");
    $State =          $xml_state->State+0; // 1 - Ready, 2 - Busy
    $busy = ($State & 2) != 0;
    $SignalQuality = myfval(explode(",",$xml_state->SignalQuality)[0]);
    
    $xml->addChild ('Success',(string) $Success );
    $xml->addChild ('SignalQuality',(string) $SignalQuality );
    $xml->addChild ('DishAngle',$xml_state->DishAngle );
    $xml->addChild ('DishCount',$xml_state->DishCountt );
    $xml->addChild ('busy',(string) $busy );
    $xml->addChild ('State',(string) $State );

    $rslt=$xml->asXML();
    header("Content-Type: text/xml");
    header("Content-Length: ".strlen($rslt)."\n");
    header("Pragma: no-cache\n");
    // allow CORS: needed for multicam controls
    header('Access-Control-Allow-Origin: *');
    printf($rslt);
    exit (0);
}

$total_cycles = 0;
if ($multi) {
    while (true) {
        $cycles = moveElAzSk_degrees($DishAngle);
        if (!isset ($cycles)) {
            break;
        }
        $total_cycles += $cycles;
    }
} else {
    $total_cycles = moveElAzSk_degrees($DishAngle);
}
$xml = new SimpleXMLElement("<?xml version='1.0'?><motosat/>");
$xml->addChild ('cycles',(string) $total_cycles );
$rslt=$xml->asXML();
header("Content-Type: text/xml");
header("Content-Length: ".strlen($rslt)."\n");
header("Pragma: no-cache\n");
// allow CORS: needed for multicam controls
header('Access-Control-Allow-Origin: *');
printf($rslt);
exit (0);

function peakAzimuth($xml_state, $az_play,$az_range, $az_step, $fract, $pow = 1.0, $argmax_outside=0.2){
    global $motosat_url,$dbg_file;
    if ($xml_state === null){
        $xml_state = simplexml_load_file($motosat_url);
    }
    $DishAngle =  getDishAngles ($xml_state);
    $az_start_center = $DishAngle[0];
    //move to sart rescan azimuth minus mechanical play
    $DishAngle[0] = $az_start_center - $az_play - $az_range/2;
    moveElAzSk_degrees($DishAngle);
    $scan_strengths = Array();
    for ($az = $az_start_center - $az_range/2;
         $az < ($az_start_center + $az_range/2 + $az_step);
         $az += $az_step){
             $DishAngle[0] = $az;
             moveElAzSk_degrees($DishAngle); // to be on the safe side re-read xml
             $modem_strength= getModemStrength();
             $scan_strengths[] = $modem_strength;
     }
     if ($dbg_file !== null) {
        fprintf($dbg_file, "==== Azimuth scan strengths: ====\n");
        fprintf($dbg_file, print_r($scan_strengths, 1));
     }
     $rel_argmax = findMax1d($scan_strengths, $fract, $pow, $argmax_outside);
    if ($rel_argmax !== null) {
        $az_argmax = $az_start_center - $az_range / 2 + $az_step * $rel_argmax;
        if ($dbg_file !== null) {
            fprintf($dbg_file, "reltive argmax = %f\n", $rel_argmax);
            fprintf($dbg_file, "azimuth argmax = %f (was %f)\n", $az_argmax, $az_start_center);
        }
        $DishAngle[0] = $az_argmax - $az_play;
        if ($dbg_file !== null) {
            fprintf($dbg_file, "====== Moving azimuth to compensate motor play to = %f\n", $DishAngle[0]);
        }
        
        moveElAzSk_degrees($DishAngle);
        $DishAngle[0] = $az_argmax;
        if ($dbg_file !== null) {
            fprintf($dbg_file, "====== Moving azimuth to argmax position = %f\n", $DishAngle[0]);
        }
        moveElAzSk_degrees($DishAngle);
    } else {
        // for now - move back
        if ($dbg_file !== null) {
            fprintf($dbg_file, "****** Failed to find maximum, going to known position.\n");
        }
        $DishAngle[0] = $az_start_center;
        moveElAzSk_degrees($DishAngle);
    }
     
     
     
     return;
}

function findMax1d($data, $fract, $pow, $frac_outside = 0.2){
    global $dbg_file;
    $min= $data[0];
    $max = $data[0];
    $argmax = 0;
    foreach ($data as $k => $v){
        if ($v > $max) {
            $max = $v;
            $argmax = $k;
        } else if ($v < $min) $min = $v;
    }
    $threshold = $min + ($max-$min)*$fract;
    $k_min = $argmax;
    while (($k_min > 0) && ($data[$k_min - 1] >= $threshold)){
        $k_min--;
    }
    $k_max = $argmax;
    $last = sizeof($data) - 1;
    while (($k_max < $last) && ($data[$k_max + 1] >= $threshold)){
        $k_max++;
    }
    $datap =  array_fill(0, sizeof($data),0);
    for ($k = $k_min; $k <= $k_max; $k++){
        $datap[$k] = $max - pow($max - $data[$k], $pow);
    }
    
    $poly_data = Array();
    for ($k = $k_min; $k <= $k_max; $k++){
       $poly_data[] = Array($k-$argmax, $datap[$k]);
    }
    
    $pa = new PolynomialApproximation();
    $pa->debugLevel = 3;
    $pa->debugFile = $dbg_file;
    
    
    $rslt = $pa->polynomialApproximation1d($poly_data, 2);
    
    
    if ($dbg_file) {
        
        fprintf($dbg_file, "argmax= %d , k_min= %d, k_max = %d, max = %f, threshold = %f, rslt:\n",
            $argmax, $k_min, $k_max, $max, $threshold);
        fprintf($dbg_file, print_r($rslt,1));
        $pre = array_fill(0, sizeof($data),0);
        $diff= array_fill(0, sizeof($data),0);
        for ($k = $k_min; $k <= $k_max; $k++){
            $x = $k-$argmax;
            $pre[$k]=$rslt[0]+$rslt[1]*$x+$rslt[2]*$x*$x;
            $diff[$k]=$pre[$k]-$datap[$k];
        }
        
        for ($k = $k_min; $k <= $k_max; $k++){
            fprintf($dbg_file, "[%02d]: %8.3f %8.3f %8.3f %8.3f\n", $k, $data[$k], $datap[$k], $pre[$k], $diff[$k]);
        }
        fprintf($dbg_file, "poly_data= \n".print_r($poly_data,1)."\n");
        
    }
    
    if (is_nan($rslt[0]) || is_nan($rslt[1]) || is_nan($rslt[2])){
        if ($dbg_file) {
            fprintf($dbg_file, "Could not find maximum (NaN): coeff = \n".print_r($rslt,1)."\n");
        }
        return null; // no maximum
    }
    
    
    if ($rslt[2] >= 0){
        if ($dbg_file) {
            fprintf($dbg_file, "Could not find maximum coeff = \n".print_r($rslt,1)."\n");
        }
        return null; // no maximum
    }
    /*
    // debugging
    $rslt[] = $argmax;
    $rslt[] = $argmax - $rslt[1] / (2 * $rslt[2]);
    $pre = array_fill(0, sizeof($data),0);
    $diff= array_fill(0, sizeof($data),0);
    for ($k = $k_min; $k <= $k_max; $k++){
        $x = $k-$argmax;
        $pre[$k]=$rslt[0]+$rslt[1]*$x+$rslt[2]*$x*$x;
        $diff[$k]=$pre[$k]-$datap[$k];
    }

    for ($k = $k_min; $k <= $k_max; $k++){
        printf("[%02d]: %8.3f %8.3f %8.3f %8.3f\n", $k, $data[$k], $datap[$k], $pre[$k], $diff[$k]);
    }

    print("data\n");
    print_r($data);
    print("datap\n");
    print_r($datap);
    print("---datap\n");
//    print_r($pre);
//    print_r($diff);
    */
//    $frac_outside = 0.2;
    $rel_argmax = $argmax - $rslt[1] / (2 * $rslt[2]);
    if ($rel_argmax < -($frac_outside * sizeof($data))){
        if ($dbg_file) {
            fprintf($dbg_file, "argmax is too low = %f, range=%d\n",$rel_argmax,sizeof($data) );
        }
        
        return null; // too low
    }
    if ($rel_argmax > ((1.0 + $frac_outside) * sizeof($data))){
        if ($dbg_file) {
            fprintf($dbg_file, "argmax is too high = %f, range=%d\n",$rel_argmax,sizeof($data) );
        }
        return null; // too low
    }
    return $rel_argmax; // $rslt;
}

/**
 * Scan rectangular AZ/EL window arownd expected satellite position, alternating 
 * azimuth directions and increasing elevation offset.
 * Start with expected elevation and low az margin, scan azimuth to high margin,
 * then alternatively increase/decrease elevation
 * @param  $threshold - minimal modem signal strength
 * @param  $DishAngleCenter - array of (elevation, azimuth, skew) in degrees,
 *                            corresponding to the center of the scan window
 * @param  $wnd_az - full range of azimuth scan in degrees
 * @param  $wnd_el - full range of elevation scan in degrees
 * @param  $scan_step - elevation scan step
 * @return SimpleXMLElement - 
 */
function scan_window($threshold, $DishAngleCenter, $wnd_az, $wnd_el, $scan_step){
    global $motosat_url,$LATE_STOP_AZ,$dbg_file;
    $DishAngle = Array($DishAngleCenter[0],$DishAngleCenter[1],$DishAngleCenter[2]);
    $dir = 0;
    for ($delta_el = 0.0; $delta_el < $wnd_el/2; $delta_el += $scan_step) {
        $passes = ($delta_el > 0.0)? 2 : 1;
        for ($pass = 0; $pass < $passes; $pass++) {
//        for ($dir = 0; $dir < 2; $dir++) {
            if ($dir > 0){
                $DishAngle[1] = $DishAngleCenter[1] + $delta_el;
                $az_start =     $DishAngleCenter[0] + $wnd_az/2;
                $az_end =       $DishAngleCenter[0] - $wnd_az/2;
            } else {
                $DishAngle[1] = $DishAngleCenter[1] - $delta_el;
                $az_start =     $DishAngleCenter[0] - $wnd_az/2;
                $az_end =       $DishAngleCenter[0] + $wnd_az/2;
            }
            
             $DishAngle[0] = $az_start;
             
             if ($dbg_file) {
                 fprintf($dbg_file, "\ndir=%d:\n",$dir);
                 fprintf($dbg_file, "wnd_az=%f:\n",$wnd_az);
                 fprintf($dbg_file, "wnd_el=%f:\n",$wnd_el);
                 fprintf($dbg_file, "threshold=%f:\n",$threshold);
                 fprintf($dbg_file, "scan_step=%f:\n",$scan_step);
                 fprintf($dbg_file, "DishAngle - start:\n");
                 fprintf($dbg_file, print_r($DishAngle,1));
                 fprintf($dbg_file, "DishAngleCenter - start:\n");
                 fprintf($dbg_file, print_r($DishAngleCenter,1));
             }
             
             while (null !==moveElAzSk_degrees($DishAngle));
             $DishAngle[0] = $az_end;
             
             if ($dbg_file) {
                 fprintf($dbg_file, "\nDishAngle - end:\n");
                 fprintf($dbg_file, print_r($DishAngle,1));
             }
             
             moveElAzSk_start_degrees($DishAngle);
             $scan_rslt = waitMotorsReady($threshold);
             if ($dbg_file) {
                 fprintf($dbg_file, "-----scan_rslt=%d:\n",$scan_rslt);
             }
             if ($scan_rslt < 0) {
                 $xml_state = simplexml_load_file($motosat_url);
                 if ($dbg_file) {
                     $DishAngle = getDishAngles ($xml_state);
                     fprintf($dbg_file, "\nDishAngle - after hitting/stopped:\n");
                     fprintf($dbg_file, print_r($DishAngle,1));
                 }
                 
                 //,$LATE_STOP_AZ
                 //move az back to compensate for late stop
                 $DishCount =  getDishCounts($xml_state);
                 if ($dir > 0){
                     $DishCount[0] += $LATE_STOP_AZ;
                 } else {
                     $DishCount[0] -= $LATE_STOP_AZ;
                 }
                 moveElAzSk_counts($DishCount);
                 if ($dbg_file) {
                     $xml_state = simplexml_load_file($motosat_url);
                     $DishAngle = getDishAngles ($xml_state);
                     fprintf($dbg_file, "\nDishAngle - after backing:\n");
                     fprintf($dbg_file, print_r($DishAngle,1));
                 }
                 $xml_state->addChild ('Success',(string) 1 );
                 return $xml_state;
             }
        }
        $dir = 1-$dir;
    }
    moveElAzSk_degrees($DishAngleCenter);
    
    while (null !==moveElAzSk_degrees($DishAngleCenter));
    $xml_state = simplexml_load_file($motosat_url);
    $xml_state->addChild ('Success',(string) 0 );
    return $xml_state;
}
//<b>49</b>
//<b><font color=red>9</font></b>
function getModemStrength(){ //0.2sec
    global $modem_strengt_url,$dbg_file;
    $modem_page=file_get_contents($modem_strengt_url);
//    $pstr="@<b>([^<]*)</b>@i";
    $pstr="@<b>(<font[^>]*>)?([^<]*)</@i";
    $matches=null; // just define
    preg_match($pstr,$modem_page, $matches);
//    return myfval($matches[1]);
    return myfval($matches[2]);
}

function moveElAzSk_start_counts($new_azelsk_count) {
    global $motosat_url, $AZ_CMAX, $EL_CMAX, $SK_CMAX,$OVERSHOOT,$dbg,$dbg_file;
    $xml_state = simplexml_load_file($motosat_url);
    $DishCount =  getDishCounts($xml_state);
    if ($DishCount[0] < 0) $DishCount[0] = 0;
    if ($DishCount[1] < 0) $DishCount[1] = 0;
    if ($DishCount[2] < 0) $DishCount[2] = 0;

    if ($DishCount[0] > $AZ_CMAX) $DishCount[0] = $AZ_CMAX;
    if ($DishCount[1] > $EL_CMAX) $DishCount[1] = $EL_CMAX;
    if ($DishCount[2] > $SK_CMAX) $DishCount[2] = $SK_CMAX;
    
    $dist_el = $new_azelsk_count[1] - $DishCount[1];
    $dist_sk = $new_azelsk_count[2] - $DishCount[2];
    $dist_az = $new_azelsk_count[0] - $DishCount[0];
    if (abs ($dist_el) <= $OVERSHOOT) $dist_el = 0;
    if (abs ($dist_sk) <= $OVERSHOOT) $dist_sk = 0;
    if (abs ($dist_az) <= $OVERSHOOT) $dist_az = 0;
    $dir =  "Up";
    $dist = 0;

    /*
     * $dist_el > 0 do it first, $dist_el < 0 - do it last 
     */    
    
    
//  if ($dist_el != 0){
    if ($dist_el > 0){
        // moving elevation up first
        $mode = "El";
        $dist = $dist_el;
        
    } else if ($dist_sk != 0){
        // moving skew second
        $mode = "Sk";
        $dist = $dist_sk;
    } else if ($dist_az != 0){
        // moving azimuth third
        $mode = "Az";
        $dist = $dist_az;
    } else if ($dist_el < 0){
        // moving elevation down last
        $mode = "El";
        $dist = $dist_el;
    }
    if ($dist != 0){
        if ($dist > 0){
            $dir =  "Up";
        } else {
            $dir =  "Dn";
        }
        $dist = abs($dist);
        $url = $motosat_url."?Action=".$mode.$dir.'&Distance='.$dist."&Units=0";
        if ($dbg_file) {
            fprintf($dbg_file, "url = %s:\n",$url);
            fprintf($dbg_file, "new_azelsk_count:\n");
            fprintf($dbg_file, print_r($new_azelsk_count,1));
            fprintf($dbg_file, "DishCount:\n");
            fprintf($dbg_file, print_r($DishCount,1));
        }
        if ($dbg) {
            echo "<!--";
            var_dump($new_azelsk_count);
            var_dump($DishCount);
            var_dump($url);
            $url = $motosat_url;
            echo "-->";
        }
        $xml_state = simplexml_load_file($url);
        return $xml_state;
    }
    return; // return null - no rotation is needed
}

function moveElAzSk_start_degrees($new_azelsk_degree) {
    global $AZ_0, $EL_0, $SK_0, $AZ_CPD, $EL_CPD, $SK_CPD,$dbg,$dbg_file;
    $new_azelsk_count = Array (
        (int) round(($new_azelsk_degree[0] + $AZ_0)*$AZ_CPD),
        (int) round(($new_azelsk_degree[1] + $EL_0)*$EL_CPD),
        (int) round(($new_azelsk_degree[2] + $SK_0)*$SK_CPD));

    if ($dbg_file) {
        $new_azelsk_count_dbg = Array (
            ($new_azelsk_degree[0] + $AZ_0)*$AZ_CPD,
            ($new_azelsk_degree[1] + $EL_0)*$EL_CPD,
            ($new_azelsk_degree[2] + $SK_0)*$SK_CPD);
        fprintf($dbg_file, "new_azelsk_degree:\n");
        fprintf($dbg_file, print_r($new_azelsk_degree,1));
        fprintf($dbg_file, "new_azelsk_count_dbg:\n");
        fprintf($dbg_file, print_r($new_azelsk_count_dbg,1));
        fprintf($dbg_file, "new_azelsk_count:\n");
        fprintf($dbg_file, print_r($new_azelsk_count,1));
    }
    if ($dbg) {
        $new_azelsk_count_dbg = Array (
        ($new_azelsk_degree[0] + $AZ_0)*$AZ_CPD,
        ($new_azelsk_degree[1] + $EL_0)*$EL_CPD,
        ($new_azelsk_degree[2] + $SK_0)*$SK_CPD);
        echo "<!--";
        var_dump($new_azelsk_degree);
        var_dump($new_azelsk_count_dbg);
        var_dump($new_azelsk_count);
        echo "-->";
    }
    return moveElAzSk_start_counts($new_azelsk_count);
}

/**
 * Wait motors stopped and optionally modem strength > threshold
 * Can be improved slightly by curl-multi:  reading modem - 0.2s, controller - 0.29s
 * @param $modem_threshold - if >0, stop on modem strength above threshold
 * @return: 0: no movement needed, >0 - number of status requests, <0 - -SignalQuality
 */
function waitMotorsReady($modem_threshold = 0.0){ //
    global $motosat_url,$dbg_file;
    $busy = true;
    $try = 0;
    while ($busy) {
        $xml_state = simplexml_load_file($motosat_url);
        $State =          $xml_state->State+0; // 1 - Ready, 2 - Busy
        $busy = ($State & 2) != 0;
        if ($modem_threshold > 0){
            $SignalQuality = myfval(explode(",",$xml_state->SignalQuality)[0]);
            if ($SignalQuality > $modem_threshold) {
                $url = $motosat_url."?Action=Stop&Distance=0&Units=0";
                $xml_state1 = simplexml_load_file($url);
                if ($dbg_file) {
                    fprintf($dbg_file, "SignalQuality= %f:\n",$SignalQuality);
                }
                
                while ($busy) {
                    $xml_state1 = simplexml_load_file($motosat_url);
                    $State =          $xml_state1->State+0; // 1 - Ready, 2 - Busy
                    $busy = ($State & 2) != 0;
                    if ($dbg_file) {
                        fprintf($dbg_file,$busy); 
                        fprintf($dbg_file, " %03d State= %d:\n",$try,$State);
                    }
                    
                }
                // Now move back to where good signal strength was detected
                $DishCountGood =  getDishCounts($xml_state);
                moveElAzSk_counts($DishCountGood);
                
                if ($dbg_file) {
                    fprintf($dbg_file, "SignalQuality= %f:\n",$SignalQuality);
                }
                
                return -$SignalQuality;
            }
        }
        $try++;
        if ($dbg_file) {
            fprintf($dbg_file, "%03d State= %d:\n",$try,$State);
        }
        
        //?Action=Stop&Distance=0&Units=0 
    }
    return $try;
}

function moveElAzSk_counts($new_azelsk_count) {
    $xml_state = moveElAzSk_start_counts($new_azelsk_count);
    if (isset ($xml_state)){
        $cycles = waitMotorsReady();
        return $cycles; // $xml_state;
    }
    return;
}

function moveElAzSk_degrees($new_azelsk_degree) {
    $xml_state = moveElAzSk_start_degrees($new_azelsk_degree);
    if (isset ($xml_state)){
        $cycles = waitMotorsReady();
        return $cycles; // $xml_state;
    }
    return;
}

function myval ($s) {
    $s=trim($s,"\" ");
    if (strtoupper(substr($s,0,2))=="0X")   return intval(hexdec($s));
    else return intval($s);
}

function myfval ($s) {
    $s=trim($s,"\" ");
    return floatval($s);
}
/**
 * Get 3 dish angles (az/el/sk) in degrees from the XML data received from controller
 * @param $xml_state : XML data from the controller
 * @return: array of 3 angles (degrees): azimuth, elevation, skew
 */
function getDishAngles($xml_state){
    $DishAngles =     explode(",",$xml_state->DishAngle);
    foreach ($DishAngles as $key => $value){
        $DishAngles[$key] = floatval($value);
    }
    return $DishAngles;
}

/**
 * Get 3 dish angles (az/el/sk) in counts from the XML data received from controller
 * @param $xml_state : XML data from the controller
 * @return: array of 3 angles (counts): azimuth, elevation, skew
 */
function getDishCounts($xml_state){
    $DishCounts =     explode(",",$xml_state->DishCount);
    foreach ($DishCounts as $key => $value){
        $DishCounts[$key] = floatval($value);
    }
    return $DishCounts;
}





?>